---
stages:
  - lint
  - unit
  - integration
  - generate_release

include:
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-commitchecker.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-lintdocs.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-generate-release.yml
    ref: master

lint:
  stage: lint
  image: python:3.7
  before_script:
    - pip install tox
  script:
    tox -e lint
  only:
    - merge_requests
    - master
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^chore\(release\)/

unit:
  stage: unit
  image: python:3.7
  coverage: '/total_coverage: ([0-9]{1,3})/'
  before_script:
    - pip install tox
  script:
    tox -e unittest
  only:
    - merge_requests
    - master
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^chore\(release\)/

integration-merge_request:
  stage: integration
  variables:
    faas_templates: |
      {
        "faas_templates": {
          "uri": "$CI_MERGE_REQUEST_SOURCE_PROJECT_URL",
          "version": "$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME"
        }
      }
    faas_functions: |
      {
        "faas": [
          {
            "name": "noop-function",
            "functions": [
              {
                "name": "piperci-noop",
                "image": "piperci-noop:local",
                "build": "true",
                "type": "local",
                "uri": "https://gitlab.com/dreamer-labs/piperci/piperci-noop-faas"
              },
            ]
          }
        ]
      }
    TYPE: functional
  only:
    - merge_requests
  trigger:
    project: dreamer-labs/piperci/piperci-integration
    strategy: depend

integration-master:
  stage: integration
  variables:
    faas_templates: |
      {
        "faas_templates": {
          "uri": "$CI_PROJECT_URL",
          "version": "master"
        }
      }
    faas_functions: |
      {
        "faas": [
          {
            "name": "noop-function",
            "functions": [
              {
                "name": "piperci-noop",
                "image": "piperci-noop:local",
                "build": "true",
                "type": "local",
                "uri": "https://gitlab.com/dreamer-labs/piperci/piperci-noop-faas"
              },
            ]
          }
        ]
      }
    TYPE: functional
  only:
    - master
  trigger:
    project: dreamer-labs/piperci/piperci-integration
    strategy: depend
